unit janButtonEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type

  TjanButtonEdit = class(TWinControl)
  private
    FButton: TBitBtn;
    FEdit: TEdit;
    procedure SetGlyph(const Value: TBitmap);
    function  GetGlyph:TBitmap;
    procedure autofit;
    procedure TextChanged(sender: TObject);
  protected
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure CreateWnd;override;
    procedure SetText(Value: String);
    function  GetText: String;
    function GetFont: TFont;
    procedure SetFont(Value: TFont);
    function GetOnButtonClick: TNotifyEvent;
    procedure SetOnButtonClick(Value: TNotifyEvent);
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
  published
    property Text: String read GetText write SetText;
    property Font: TFont read GetFont write SetFont;
    property OnButtonClick: TNotifyEvent read GetOnButtonClick write SetOnButtonClick;
    property Glyph:TBitmap read GetGlyph write SetGlyph;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Jans 2', [TjanButtonEdit]);
end;


procedure TjanButtonEdit.WMSize(var Message: TWMSize);
begin
  inherited;
  autofit;
end;

constructor TjanButtonEdit.Create(AOwner: TComponent);
begin
  inherited;
  width:=121;
  height:=24;
  FEdit:=TEdit.Create (self);
  FEdit.parent:=self;
  FEdit.onchange:=TextChanged;
  FButton:=TBitbtn.Create (self);
  FButton.width:=20;
  Fbutton.height:=20;
  Fbutton.top:=2;
  FButton.parent:=Self;
  FButton.Caption :='';
end;

destructor  TjanButtonEdit.Destroy;
begin
  FButton.Free;
  FEdit.Free;
  inherited Destroy;
end;

function TjanButtonEdit.GetText: String;
begin
  Result := FEdit.Text;
end;

procedure TjanButtonEdit.SetText(Value: String);
begin
  FEdit.Text := Value;
  autofit;  
end;

function TjanButtonEdit.GetFont: TFont;
begin
  Result := FEdit.Font;
end;

procedure TjanButtonEdit.SetFont(Value: TFont);
begin
  if Assigned(FEdit.Font) then
    FEdit.Font.Assign(Value);
end;

function TjanButtonEdit.GetOnButtonClick: TNotifyEvent;
begin
  Result := FButton.OnClick;
end;

procedure TjanButtonEdit.SetOnButtonClick(Value: TNotifyEvent);
begin
  FButton.onClick := Value;
end;

procedure TjanButtonEdit.SetGlyph(const Value: TBitmap);
begin
  FButton.Glyph.assign(Value);
end;

function TjanButtonEdit.GetGlyph: TBitmap;
begin
  result:=FButton.Glyph;
end;


procedure TjanButtonEdit.CreateWnd;
begin
  inherited;
  FEdit.width:=width;
  FEdit.height:=height;
  autofit;
end;

procedure TjanButtonEdit.autofit;
begin
  FEdit.width:=width;
  FEdit.height:=height;
  Fbutton.top:=2;
  Fbutton.Height :=height-4;
  Fbutton.Left := Width-FButton.width-3;
  FEdit.Perform(EM_SETMARGINS,EC_RIGHTMARGIN,(FButton.Width+4)*$10000);
end;

procedure TjanButtonEdit.TextChanged(sender: TObject);
begin
  FEdit.Perform(EM_SETMARGINS,EC_RIGHTMARGIN,(FButton.Width+4)*$10000);
end;

end.
